ig.module(
    'game.entities.barrier'
)
.requires(
    'impact.entity'
)
.defines(function(){
    
EntityBarrier = ig.Entity.extend({
    _wmDrawBox: true,
    _wmBoxColor: 'rgba(100, 100, 0, 0.7)',
    size: {x:30, y:30},
    maxVel: {x:0, y:0},
    value: 40,
    sfxExplosion: new ig.Sound( 'media/boom.ogg' ),
    collides: ig.Entity.COLLIDES.PASSIVE,
    checkAgainst: ig.Entity.TYPE.A,
    type: ig.Entity.TYPE.B,  //Enemy
    image: new ig.Image('media/barrier.png'),
    health: 1,
    
    init: function( x, y, settings ) {
        this.parent( x, y, settings );
        this.vel.x = 0;
        this.vel.y = 0;
    },
    
    update: function() {
        this.parent();
    },
    
    draw: function() {
        this.image.draw(this.pos.x, this.pos.y);
        this.parent();
    },
    check: function(other) {
        other.kill();
    },
    kill: function() {
        this.parent();
        this.sfxExplosion.play();
        ig.game.score += this.value;
    }
});


});
