ig.module(
    'game.entities.laser'
)
.requires(
    'impact.entity'
)
.defines(function(){
    
EntityLaser = ig.Entity.extend({
    size: {x:30, y:30},
    maxVel: {x:600, y:600},
    _wmScalable: true,
    image: new ig.Image('media/laser_bot.png'),
    collides: ig.Entity.COLLIDES.PASSIVE,
    checkAgainst: ig.Entity.TYPE.A,
    sfxFire: new ig.Sound( 'media/laser.ogg' ),
    health: 9999,
    type: ig.Entity.TYPE.B,  //Enemy
    
    init: function( x, y, settings ) {
        this.parent( x, y, settings );
        this.vel.x = 0;
        this.vel.y = 0;
        this.active = false;
        this.fireTimer = new ig.Timer(1);
        this.color = "rgb(255,0,0)";
        
    },
    
    update: function() {
        this.parent();
        if(this.fireTimer.delta()>0){
            this.active = !this.active;
            if (this.active) {
                this.sfxFire.play();
            } else {
                this.sfxFire.stop();
            }
            this.fireTimer.reset();
        }
    },
    draw: function() {
        if (this.active) {
            var ctx = ig.system.context;
            var s = ig.system.scale;
            var x = this.pos.x * s + 10; // - ig.game.screen.x * s;
            var y = this.pos.y * s + 25; // - ig.game.screen.y * s;
            var sizeX = this.size.x * s - 20;
            var sizeY = this.size.y * s - 50;
            ctx.fillStyle = this.color;
            ctx.fillRect (x, y, sizeX, sizeY);
        }
        this.image.drawTile(this.pos.x, this.pos.y, 0, 30, 20, false, true);
        this.image.drawTile(this.pos.x, this.pos.y + this.size.y - 20, 0, 30, 20);
        this.parent();
    },
    check: function(other) {
        if (this.active || (other.pos.y < this.pos.y + 20)  || (other.pos.y + other.size.y > this.pos.y + this.size.y - 20)) {
            other.kill();
        }
    }    
});


});
