ig.module(
    'game.entities.missil'
)
.requires(
    'impact.entity'
)
.defines(function(){
    
EntityMissil = ig.Entity.extend({
    size: {x:25, y:30},
    maxVel: {x:600, y:600},
//     animSheet: new ig.AnimationSheet( 'media/alien.png', 40, 22 ),  
    collides: ig.Entity.COLLIDES.PASSIVE,
    checkAgainst: ig.Entity.TYPE.A,
    type: ig.Entity.TYPE.B,  //Enemy
    orientation: 'S',
    health: 1,
    sfxLaunch: new ig.Sound( 'media/missil.ogg' ),
    sfxExplosion: new ig.Sound( 'media/boom.ogg' ),
    image: {'S': new ig.Image('media/missilS.png'), 'N': new ig.Image('media/missilN.png')},
    value: 100,
    span: 350,
    
    init: function( x, y, settings ) {
        this.parent( x, y, settings );
        this.vel.x = 0;
        this.vel.y = 0;
    },
    
    update: function() {
        this.parent();
        if ((this.vel.x == 0) && (this.vel.y == 0)) {
            var player = ig.game.getEntityByName('player');
            if (player) {
                var d = this.distanceTo(player);
                if (d < this.span) {
                    var a = 500 - d;
                    if (this.orientation == 'N') {
                        a = -a;
                    }
                    this.fire(0, a);
                }
            }
        }
    },
    
    fire: function(ax, ay) {
        this.accel.x = ax;
        this.accel.y = ay;
        this.sfxLaunch.play();
    },
    draw: function() {
        this.image[this.orientation].draw(this.pos.x, this.pos.y);
        this.parent();
    },
    check: function(other) {
        other.kill();
        this.kill();
    },
    handleMovementTrace: function( res ) {
        this.parent(res);
        if (res.collision.x || res.collision.y) {
            this.kill(true);
        }
    },
    kill: function(np) {
        this.parent();
        this.sfxLaunch.stop();
        this.sfxLaunch.volume = 0;
        this.sfxExplosion.play();
        if (!np) {
            ig.game.score += this.value;
        }
    },    
});


});
