ig.module(
    'game.entities.player'
)
.requires(
    'impact.entity'
)
.defines(function(){

    EntityExplosion = ig.Entity.extend({
    size: {x:30, y:28},
    type: ig.Entity.TYPE.NONE,
    animSheet: new ig.AnimationSheet('media/explosion.png', 30, 28),
    init: function( x, y, settings ) {
        this.parent( x, y, settings );
        this.addAnim('explosion', 0.1, [0, 1, 2]);
    },
    
    update:function(){
        this.parent();
        
        if(this.currentAnim.loopCount){
            this.kill();
        }
    }
})
 

EntityPlayer = ig.Entity.extend({
    size: {x:30, y:22},
    maxVel: {x:600, y:600},
    images: {'W': new ig.Image('media/ship2.png'), 'E': new ig.Image('media/ship.png')},  // Também se pode fazer isto com uma animação com uma frame
    fireTimer: new ig.Timer(),
    canShoot: true,
    sfxFire: new ig.Sound( 'media/shoot.ogg' ),
    sfxExplosion: new ig.Sound( 'media/die.ogg' ),
    type: ig.Entity.TYPE.A,
    facing: undefined,
    dead: false,
    init: function( x, y, settings ) {
        this.facing = 'E';
        this.parent( x, y, settings );
        this.fireTimer.set(0.5); //s
    },
    
    update: function() {
        if(this.fireTimer.delta()>0){
            this.canShoot = true;
        }
        
        if( ig.input.state('left') ) {
            this.vel.x = -200;
            this.facing = 'W';
        }
        else if( ig.input.state('right') ) {
            this.vel.x = 200;
            this.facing = 'E';
        }
        else {
            this.vel.x = 0;
        }
        if( ig.input.state('up') ) {
            this.vel.y = -200;
        }
        else {
            this.vel.y = 100;
        }
        
        if( ig.input.state('fire') && this.canShoot) {
            var x, y, s;
            y = this.pos.y+(this.size.y)-5;
            if (this.facing == 'E') {
                x = this.pos.x + this.size.x + 1;
                s = {vx: BULLET_SPEED, vy:0}
            } else {
                x = this.pos.x - 6;
                s = {vx: -BULLET_SPEED, vy:0}
            }
            ig.game.spawnEntity(EntityBullet, x, y, s);
            this.sfxFire.play();
            this.canShoot = false;
            this.fireTimer.reset();
        }
        
        this.parent();
        if (this.pos.x < 0) {
            this.pos.x = 0;
        } else if (this.pos.x > (ig.system.width-this.size.x)) {
            this.pos.x = (ig.system.width-this.size.x);
        }
        if (this.pos.y < 0) {
            this.pos.y = 0;
        } else if (this.pos.y > (ig.system.height-this.size.y)) {
            this.pos.y = (ig.system.height-this.size.y);
        }
    },
    
    draw: function() {
        this.images[this.facing].draw(this.pos.x, this.pos.y); 
    },
    kill: function() {
        this.dead = true;
        this.sfxExplosion.play();
        ig.game.spawnEntity(EntityExplosion, this.pos.x, this.pos.y);
        this.parent();
        ig.game.death();
    }
});



});
